<doxygen xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" version="1.8.13" xsi:noNamespaceSchemaLocation="compound.xsd">
  <compounddef id="group__group__dmac" kind="group">
    <compoundname>group_dmac</compoundname>
    <title>DMAC         (Direct Memory Access Controller)</title>
    <innergroup refid="group__group__dmac__macros">Macros</innergroup>
    <innergroup refid="group__group__dmac__macros__interrupt__masks">Interrupt Masks</innergroup>
    <innergroup refid="group__group__dmac__functions">Functions</innergroup>
    <innergroup refid="group__group__dmac__data__structures">Data Structures</innergroup>
    <innergroup refid="group__group__dmac__enums">Enumerated Types</innergroup>
    <briefdescription>
<para>Configures the DMA Controller block, channels and descriptors. </para>    </briefdescription>
    <detaileddescription>
<para>The functions and other declarations used in this driver are in cy_dmac.h. You can include cy_pdl.h to get access to all functions and declarations in the PDL.</para><para>The DMA Controller channel can be used in any project to transfer data without CPU intervention basing on a hardware trigger signal from another component.</para><para>The DMA Controller block has a set of registers, a base hardware address, and supports multiple channels. Many API functions for the DMAC driver require a base hardware address and channel number. Ensure that you use the correct hardware address for the DMA Controller block in use.</para><para>Features:<itemizedlist>
<listitem><para>Multiple channels (device specific).</para></listitem><listitem><para>Four priority levels for each channel.</para></listitem><listitem><para>Descriptor chaining.</para></listitem><listitem><para>Configurable data transfer width/masking: byte, half-word (2-byte), and word (4-byte).</para></listitem><listitem><para>Configurable source and destination addresses.</para></listitem><listitem><para>Single transfer, 1D, 2D, memory copy and scatter transfer descriptor types are supported.</para></listitem><listitem><para>Configurable input/output triggers and interrupts.</para></listitem></itemizedlist>
</para>
<para><heading level="1">Configuration Considerations</heading></para>
<para>To set up a DMAC driver, initialize a descriptor, initialize and enable a channel, and enable the DMAC block.</para><para>To set up a descriptor, provide the configuration parameters for the descriptor in the <ref kindref="compound" refid="structcy__stc__dmac__descriptor__config__t">cy_stc_dmac_descriptor_config_t</ref> structure. Then call the <ref kindref="member" refid="group__group__dmac__descriptor__functions_1gad4204ef079b02d9afdd9328f0cd461f9">Cy_DMAC_Descriptor_Init</ref> function to initialize the descriptor in SRAM. You can modify the source and destination addresses dynamically by calling <ref kindref="member" refid="group__group__dmac__descriptor__functions_1ga6b71b6054e4e16bb3ba58bfdd5bab2cc">Cy_DMAC_Descriptor_SetSrcAddress</ref> and <ref kindref="member" refid="group__group__dmac__descriptor__functions_1gad9a9e073cd42384059732d86bd3c8dbf">Cy_DMAC_Descriptor_SetDstAddress</ref>.</para><para>To set up a DMAC channel, provide a filled <ref kindref="compound" refid="structcy__stc__dmac__channel__config__t">cy_stc_dmac_channel_config_t</ref> structure. Call the <ref kindref="member" refid="group__group__dmac__channel__functions_1ga7b508e6cc332b4d009bf9b09ed6529b3">Cy_DMAC_Channel_Init</ref> function, specifying the channel number. Use <ref kindref="member" refid="group__group__dmac__channel__functions_1gab39e11c3ad72ebfd07cdd9840385769b">Cy_DMAC_Channel_Enable</ref> to enable the configured DMAC channel.</para><para>Call <ref kindref="member" refid="group__group__dmac__channel__functions_1gab39e11c3ad72ebfd07cdd9840385769b">Cy_DMAC_Channel_Enable</ref> for each DMAC channel in use.</para><para>When configured, another peripheral typically triggers the DMAC channel. The trigger is connected to the DMAC channel using the trigger multiplexer. The trigger multiplexer driver has a software trigger you can use in firmware to trigger the DMAC channel. See the <ulink url="group__group__trigmux.html">Trigger Multiplexer</ulink> documentation.</para><para>The following is a simplified structure of the DMAC driver API interdependencies in a typical user application: <image name="dmac.png" type="html" />
</para><para><bold>NOTE:</bold> Even if a DMAC channel is enabled, it is not operational until the DMAC block is enabled using function <ref kindref="member" refid="group__group__dmac__block__functions_1ga3f45f389340c3282c59d6ffe6e5040b5">Cy_DMAC_Enable</ref>.<linebreak />
<bold>NOTE:</bold> If the DMAC descriptor is configured to generate an interrupt, the interrupt must be enabled using the <ref kindref="member" refid="group__group__dmac__channel__functions_1gae0485c56ffe98283f8b9326ee6d516ae">Cy_DMAC_Channel_SetInterruptMask</ref> function for each DMAC channel.</para><para>For example: <programlisting><codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Scenario:<sp />Initialize<sp />a<sp />1D<sp />descriptor<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor"><sp /><sp /><sp /><sp />#define<sp />DATACNT<sp />(8UL)</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="compound" refid="structcy__stc__dmac__descriptor__t">cy_stc_dmac_descriptor_t</ref><sp />descriptor;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="compound" refid="structcy__stc__dmac__descriptor__t">cy_stc_dmac_descriptor_t</ref><sp />nextDescriptor;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />uint32_t<sp />src[DATACNT];</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />uint32_t<sp />dst[DATACNT];</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="compound" refid="structcy__stc__dmac__descriptor__config__t">cy_stc_dmac_descriptor_config_t</ref><sp />descriptor_cfg<sp />=<sp /></highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.<ref kindref="member" refid="structcy__stc__dma__descriptor__config__t_1afcc039279bc1e7d50b0813778772f3c0">retrigger</ref><sp />=<sp /><ref kindref="member" refid="group__group__dmac__enums_1gga016be77931e116644c70e934101dd7c3ab796353bb8bb6f244bb8f6d94d002396">CY_DMAC_RETRIG_IM</ref>,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.interruptType<sp />=<sp /><ref kindref="member" refid="group__group__dmac__enums_1gga78bb44cea66b230aadd012c5bae864a3a274e048caf530edf7ef6159face7c486">CY_DMAC_DESCR</ref>,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.triggerOutType<sp />=<sp /><ref kindref="member" refid="group__group__dmac__enums_1gga78bb44cea66b230aadd012c5bae864a3a274e048caf530edf7ef6159face7c486">CY_DMAC_DESCR</ref>,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.channelState<sp />=<sp /><ref kindref="member" refid="group__group__dmac__enums_1gga0e57c8ab013d71005b81e60c2c4ee7a9acbff6554ce23780e0fcf2af9e97816cc">CY_DMAC_CHANNEL_ENABLED</ref>,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.triggerInType<sp />=<sp /><ref kindref="member" refid="group__group__dmac__enums_1gga78bb44cea66b230aadd012c5bae864a3a274e048caf530edf7ef6159face7c486">CY_DMAC_DESCR</ref>,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.dataSize<sp />=<sp /><ref kindref="member" refid="group__group__dmac__enums_1ggac2fda05300faa05ecfc118f22ed2a3c5ad4112bd05bdc21a993b63b0957bfacf8">CY_DMAC_WORD</ref>,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.srcTransferSize<sp />=<sp /><ref kindref="member" refid="group__group__dmac__enums_1gga678295e9e6a31ad41feab278d0faf4d1a108838a4e9ea224b4a471593b6484471">CY_DMAC_TRANSFER_SIZE_WORD</ref>,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.dstTransferSize<sp />=<sp /><ref kindref="member" refid="group__group__dmac__enums_1gga678295e9e6a31ad41feab278d0faf4d1a108838a4e9ea224b4a471593b6484471">CY_DMAC_TRANSFER_SIZE_WORD</ref>,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.descriptorType<sp />=<sp /><ref kindref="member" refid="group__group__dmac__enums_1ggafc067b535081b9cd83fa29b9e68b002ca700cc18061eb5de2f16f3dc1ee96fbe8">CY_DMAC_1D_TRANSFER</ref>,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.srcAddress<sp />=<sp />&amp;src,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.dstAddress<sp />=<sp />&amp;dst,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.srcXincrement<sp />=<sp />1U,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.dstXincrement<sp />=<sp />1U,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.xCount<sp />=<sp />DATACNT,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.srcYincrement<sp />=<sp />0U,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.dstYincrement<sp />=<sp />0U,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.yCount<sp />=<sp />1UL,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />.nextDescriptor<sp />=<sp />&amp;nextDescriptor,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />};</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(<ref kindref="member" refid="group__group__dmac__enums_1gga67fe9048608517c9cdebbe0372866eb5a5c4b9c1a66c7776ddc98a5b3dedac160">CY_DMAC_SUCCESS</ref><sp />!=<sp /><ref kindref="member" refid="group__group__dmac__descriptor__functions_1gad4204ef079b02d9afdd9328f0cd461f9">Cy_DMAC_Descriptor_Init</ref>(&amp;descriptor,<sp />&amp;descriptor_cfg))</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Insert<sp />error<sp />handling<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Scenario:<sp />Setup<sp />and<sp />enable<sp />the<sp />DMAC<sp />channel<sp />0<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="compound" refid="structcy__stc__dmac__channel__config__t">cy_stc_dmac_channel_config_t</ref><sp />channelConfig;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />channelConfig.<ref kindref="member" refid="structcy__stc__dmac__channel__config__t_1a01cab162709493ed756b6cb21219ff51">enable</ref><sp />=<sp /></highlight><highlight class="keyword">false</highlight><highlight class="normal">;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />channelConfig.<ref kindref="member" refid="structcy__stc__dmac__channel__config__t_1ade9585ff561af6ad292932293e0bd15d">bufferable</ref><sp />=<sp /></highlight><highlight class="keyword">false</highlight><highlight class="normal">;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">if</highlight><highlight class="normal"><sp />(<ref kindref="member" refid="group__group__dmac__enums_1gga67fe9048608517c9cdebbe0372866eb5a5c4b9c1a66c7776ddc98a5b3dedac160">CY_DMAC_SUCCESS</ref><sp />!=<sp /><ref kindref="member" refid="group__group__dmac__channel__functions_1ga7b508e6cc332b4d009bf9b09ed6529b3">Cy_DMAC_Channel_Init</ref>(DMAC,<sp />0UL,<sp />&amp;channelConfig))</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Insert<sp />error<sp />handling<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__dmac__channel__functions_1ga0ea7589df07e40e6723dc7f992e6994b">Cy_DMAC_Channel_SetDescriptor</ref>(DMAC,<sp />0UL,<sp />&amp;descriptor);</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__dmac__channel__functions_1ga4e68ab04d5de2d6a1b31779741aa64db">Cy_DMAC_Channel_SetPriority</ref>(DMAC,<sp />0UL,<sp />3UL);</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__dmac__channel__functions_1gab39e11c3ad72ebfd07cdd9840385769b">Cy_DMAC_Channel_Enable</ref>(DMAC,<sp />0UL);</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__dmac__block__functions_1ga3f45f389340c3282c59d6ffe6e5040b5">Cy_DMAC_Enable</ref>(DMAC);</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight></codeline>
</programlisting> </para>

<para><heading level="1">More Information.</heading></para>
<para>See the DMAC chapter of the device technical reference manual (TRM).</para>

<para><heading level="1">MISRA-C Compliance</heading></para>
<para>The DMAC driver has the following specific deviations:</para><para><verbatim>embed:rst 
.. raw:: html

  &lt;table class="docutils align-default"&gt;&lt;tr&gt;&lt;td class="head"&gt;&lt;p&gt;MISRA Rule &lt;/p&gt;&lt;/td&gt;&lt;td class="head"&gt;&lt;p&gt;Rule Class (Required/Advisory) &lt;/p&gt;&lt;/td&gt;&lt;td class="head"&gt;&lt;p&gt;Rule Description &lt;/p&gt;&lt;/td&gt;&lt;td class="head"&gt;&lt;p&gt;Description of Deviation(s)  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;10.3 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;R &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;A composite expression of the "essentially unsigned" type is being cast to a different type category. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;The value got from the bitfield physically cannot exceed the enumeration that describes this bitfield. So, the code is safe by design.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;11.4 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;A &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;A cast should not be performed between a pointer to object type and a different pointer to object type. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;The cast to another type is made intentionally for better code readability.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;/table&gt;</verbatim></para>

<para><heading level="1">Changelog</heading></para>
<para><verbatim>embed:rst 
.. raw:: html

  &lt;table class="docutils align-default"&gt;&lt;tr&gt;&lt;td class="head"&gt;&lt;p&gt;Version&lt;/p&gt;&lt;/td&gt;&lt;td class="head"&gt;&lt;p&gt;Changes&lt;/p&gt;&lt;/td&gt;&lt;td class="head"&gt;&lt;p&gt;Reason for Change &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;1.10.1 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Minor documentation updates. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Documentation enhancement.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;1.10 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;The &lt;a href="group__group__dmac__channel__functions.html#group__group__dmac__channel__functions_1ga31fbd71a93ff4332b8e8df56090f9423"&gt;Cy_DMAC_Channel_ClearInterrupt&lt;/a&gt; is changed. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Minor defect fixing.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;1.0 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;The initial version. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p /&gt;&lt;/td&gt;&lt;/tr&gt;&lt;/table&gt;</verbatim></para>
    </detaileddescription>
  </compounddef>
</doxygen>